// *** TUBO DE ENSAYO ***
#macro tubo_ensayo(liquido,color_liquido,altura_liquido)
#local tubo=
merge{
 difference{
  cylinder{<0,-5,0>,<0,5,0>,1.0}
  cylinder{<0,-5.1,0>,<0,5.1,0>,0.9}
 }
 intersection{
  torus{1.0,.05}
  plane{y,0 inverse}
  translate 5*y
 }
 intersection{
  difference{
   sphere{0,1.0}
   sphere{0,0.9}
  }
  plane{y,0}
  translate -5*y
 }
 texture{t_cristal_tubo}
}
#if (liquido)
 union{
  object{tubo}
  merge{
   cylinder{<0,-5,0>,<0,-5+10*altura_liquido,0>,0.89
    texture{
     pigment{color_liquido}
     finish{Glass_Finish ior 1.2 caustics 16}
    }
   }
   intersection{
    sphere{0,0.89}
    plane{y,0.01}
    texture{
     pigment{color_liquido}
     finish{Glass_Finish ior 1.2 caustics 16}
    }
    translate -5*y
   }
  }
 }
#else
 object{tubo}
#end
#end
// *** PROBETA ***
#macro probeta(liquido,color_liquido,altura_liquido)
#local prob0=
merge{
 difference{
  cylinder{<0,-5,0>,<0,5,0>,1.0}
  cylinder{<0,-5.1,0>,<0,5.1,0>,0.9}
 }
 intersection{
  torus{1.0,.05}
  plane{y,0 inverse}
  translate 5*y
 }
 intersection{
  difference{
   sphere{0,1.0}
   sphere{0,0.9}
  }
  plane{y,0}
  translate -5*y
 }
 lathe{
  cubic_spline
  7
  <0,0>
  <0,0>
  <2,0>
  <2,.2>
  <1.5,.5>
  <1,1>
  <0,1>
  translate -5*y
 }
 texture{t_cristal_tubo}
}
#if (liquido)
 union{
  object{prob0}
  merge{
   cylinder{<0,-5,0>,<0,-5+10*altura_liquido,0>,0.89
    texture{
     pigment{color_liquido}
     finish{Glass_Finish ior 1.2 caustics 16}
    }
   }
   intersection{
    sphere{0,0.89}
    plane{y,0.01}
    texture{
     pigment{color_liquido}
     finish{Glass_Finish ior 1.2 caustics 16}
    }
    translate -5*y
   }
  }
  translate 5*y
 }
#else
 object{prob0
  translate 5*y
 }
#end
#end
// *** DESTILADORA ***
#declare abrazadera=
union{
 torus{1.3,.2 translate  .4*y}
 torus{1.3,.2 translate -.4*y}
 torus{.4,.2 rotate 90*z translate -1.2*z rotate 0*y}
 torus{.4,.2 rotate 90*z translate -1.2*z rotate 90*y}
 torus{.4,.2 rotate 90*z translate -1.2*z rotate 180*y}
 torus{.4,.2 rotate 90*z translate -1.2*z rotate 270*y}
 pigment{Orange*.6+Pink*.5} finish{Phong_Shiny}
}
#declare destiladora=
union{
 object{pot00
  scale <.3,1.5*.9,.3>
  texture{t_cristal_tubo}
 }
 object{matraz3
  scale .8
  scale .9
  translate <14,0,-4>
 }
 sphere_sweep{
  b_spline_sphere_sweep
  7
  <0,0,0>,1
  <0,4,0>,1
  <0,10,0>,1
  <7,7.5,-2>,1
  <14,5,-4>,1
  <14,-2,-4>,1
  <14,-10,-4>,1
  texture{t_cristal_tubo}
  translate 18*y
 }
 object{abrazadera translate <0,23,0>}
 object{abrazadera translate <14,18.5,-4>}
}
